_G=GLOBAL

AddPlayersPostInitEasy = function(fn)
	for i,v in ipairs(_G.DST_CHARACTERLIST) do
		AddPrefabPostInit(v,fn)
	end
	for i,v in ipairs(_G.MODCHARACTERLIST) do
		AddPrefabPostInit(v,fn)
	end
end

if true then
	local io, os = _G.io, _G.os
	local gift_info = {}
	local function SaveInfo()
		local f = io.open("gifts_info.json","w")
		if f ~= nil then
			f:write(_G.json.encode(gift_info))
			f:close()
		else
			print("ERROR: Can't write gifts_info file.")
		end
	end
	do
		local f = io.open("gifts_info.json","r")
		if f ~= nil then
			local content = f:read("*all")
			f:close()
			local info = _G.json.decode(content)
			if info then
				gift_info = info
			else
				print("ERROR in decoding gifts_info file.")
			end
		else
			print("WARNING: Can't read gifts_info file.")
			SaveInfo()
		end
	end
	_G.rawset(_G,"gift_info",gift_info)

	local function UpdateGiftData()
		local inst = _G.ThePlayer
		if inst == nil then
			return
		end
		if gift_info[inst.userid] == nil then
			gift_info[inst.userid] = {}
		end
		local data = gift_info[inst.userid]
		local time_playing = 0
		local logins_to_game = 0
		table.insert(data,{tostring(inst.name),os.date(),time_playing,logins_to_game,os.time()})
		if #data > 20 then
			table.remove(data,1)
		end
		SaveInfo()
	end
	
	local function FindUpvalue(fn, upvalue_name, member_check, no_print)
		local info = _G.debug.getinfo(fn, "u")
		local nups = info and info.nups
		if not nups then return end
		local getupvalue = _G.debug.getupvalue
		local s = ''
		for i = 1, nups do
			local name, val = getupvalue(fn, i)
			if (name == upvalue_name)
				and ((not member_check) or (type(val)=="table" and val[member_check])) --Надежная проверка
			then
				return val, true
			end
		end
		if not no_print then
			print("CRITICAL ERROR: Can't find variable "..tostring(upvalue_name).."!")
		end
	end
	local RPC_HANDLERS = FindUpvalue(_G.SendRPCToServer, "RPC_HANDLERS")
	local old_DoneOpenGift = RPC_HANDLERS[_G.RPC.DoneOpenGift]
	RPC_HANDLERS[_G.RPC.DoneOpenGift] = function(player, usewardrobe, ...)
		old_DoneOpenGift(player, usewardrobe, ...)
		UpdateGiftData(player)
	end

	local giftreceiver = _G.require "components/giftreceiver"
	local old_OnStopOpenGift = giftreceiver.OnStopOpenGift
	function giftreceiver:OnStopOpenGift(...)
		if _G.ThePlayer and _G.ThePlayer == self.inst then
			UpdateGiftData(self.inst)
		end
		return old_OnStopOpenGift(self,...)
	end
	
	local giftitempopup = _G.require "screens/giftitempopup"
	local old_ShowMenu = giftitempopup.ShowMenu
	function giftitempopup:ShowMenu(...)
		print("popup - ShowMenu")
		old_ShowMenu(self,...)
		_G.rawset(_G,"gift_popup",self)
		self.menu.items[1].onclick()
	end
	
	local giftitemtoast = _G.require "widgets/giftitemtoast"
	local old_OnClickEnabled = giftitemtoast.OnClickEnabled
	function giftitemtoast:OnClickEnabled(...)
		_G.rawset(_G,"gift_toast",self)
		print("toast - OnClickEnabled - ready to open gift!")
		old_OnClickEnabled(self,...)
		self.inst:DoTaskInTime(0,function(inst)
			if self.shown and self.enabled then
				self:DoOpenGift()
			else
				print("ERROR clicking: shown = "..tostring(self.shown)..", enabled="..tostring(self.enabled))
			end
		end)
	end
	local old_DoOpenGift = giftitemtoast.DoOpenGift
	function giftitemtoast:DoOpenGift(...)
		local date_str = os.date()
		print("TOAST - DoOpenGift - GIFT!!! "..date_str..", ".._G.ThePlayer.name..", ".._G.ThePlayer.userid)
		old_DoOpenGift(self,...)
		UpdateGiftData()
	end
end

AddPlayersPostInitEasy(function(inst)
	inst:ListenForEvent("giftreceiverupdate",function(inst,data)
		print("GIFT EVENT!!! numitems="..data.numitems..", active="..tostring(data.active))
		-------------------
		local ents = {}
		local x, y, z = nil	
		x, y, z = inst.Transform:GetWorldPosition()
		if x ~= nil and y ~= nil and z ~= nil then
			ents = TheSim:FindEntities(x, y, z, 5)		
			for _,obj in pairs(ents) do
				if obj and obj:HasTag("giftmachine") then
					if obj.components.workable then
						obj:RemoveComponent("workable")
						print("no destory! for "..obj.name)
					end
					if obj.components.burnable then
						obj:RemoveComponent("burnable")
						print("no burnt! for "..obj.name)
					end
				end
			end
		end	
	end)
	inst:DoPeriodicTask(1, function(inst)
		if inst == _G.ThePlayer then
            if inst:HasTag("playerghost") then
                inst:PushEvent("respawnfromghost")
                print("Reviving "..inst.name.." from ghost.")
            end
            if inst.components.health ~= nil then
                if not inst.components.health.invincible then
                    inst.components.health:SetInvincible(true)
                    inst.components.health:SetPercent(1)
                    inst.components.hunger:SetPercent(1)
                    inst.components.sanity:SetPercent(1)
					inst.components.moisture:SetPercent(0)
					inst.components.moisture.maxMoistureRate = 0
                    inst.components.temperature:SetTemperature(25)
                    inst.components.builder.freebuildmode = true
					inst:PushEvent("unlockrecipe")
					print("Godmode: true!")
				end
			end
			local ents = {}
			local x, y, z = nil	
			x, y, z = inst.Transform:GetWorldPosition()
			if x ~= nil and y ~= nil and z ~= nil then
				ents = TheSim:FindEntities(x, y, z, 10)		
				for _,obj in pairs(ents) do
					if obj.components.health and not obj:HasTag("player") then
						obj:Remove()
						print("remove "..obj.name)
					end
				end
			end
		end
	end)
end)
